import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis } from "./ISortingAxis";
import { IDateTimeAxis } from "./IDateTimeAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { IList$1, Type } from "igniteui-angular-core";
import { AxisOrientation } from "./AxisOrientation";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { SortedListView$1 } from "./SortedListView$1";
import { Series } from "./Series";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
/**
 * @hidden
 */
export declare abstract class TimeAxisBase extends CategoryAxisBase implements ISortingAxis, IDateTimeAxis {
    static $t: Type;
    constructor();
    dw(a: number, b: ScalerParams): number;
    e4(a: any, b: string): any;
    private ld;
    private le;
    dz(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    i$h(): void;
    lt(): void;
    protected ly(): void;
    dateTimeMemberPath: string;
    kx: IFastItemColumn$1<Date>;
    private kw;
    private k5;
    protected k6: List$1<number>;
    readonly i$b: List$1<number>;
    protected lu(): void;
    i$e(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected lg(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected lf(a: Date): number;
    i$g(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected lj(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected li(a: Date): number;
    i$d(a: number): number;
    i$c(a: number): number;
    protected lh(a: Date, b: SortedListView$1<Date>): number;
    i$f(a: number): number;
    i$i(): void;
    k2: boolean;
    private k0;
    protected get_k1(): boolean;
    protected set_k1(a: boolean): void;
    k1: boolean;
    gw(a: string): void;
    gz(a: any): void;
    gy(a: any): void;
    cn(): boolean;
    protected k4(): boolean;
    protected k3(): boolean;
    private k8;
    actualMinimumValue: Date;
    private k7;
    e9(): any;
    actualMaximumValue: Date;
    e8(): any;
    minimumValue: Date;
    maximumValue: Date;
    private lv;
    protected gu(a: any, b: string, c: any, d: any): void;
    private ls;
    protected ky(a: string): IFastItemColumn$1<Date>;
    static kz(a: string, b: CategoryAxisBase): IFastItemColumn$1<Date>;
    as(): AxisLabelPanelBase;
    protected get_az(): AxisOrientation;
    readonly az: AxisOrientation;
    protected g7(a: boolean): void;
    protected get_b5(): boolean;
    protected startCursor(): void;
    protected resetCursor(): void;
    StartTimeCursor(): void;
    ResetTimeCursor(): void;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    jr(a: Rect, b: Rect, c: Rect): number;
    protected get_cd(): boolean;
    protected lr(a: Date, b: Date): number;
    preferredCategoryMode(a: Series): CategoryMode;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    readonly i$a: boolean;
    static $$p: string[];
}
